## tree-sitter 0.25.6

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(tree-sitter
        VERSION "0.25.6"
        DESCRIPTION "An incremental parsing system for programming tools"
        HOMEPAGE_URL "https://tree-sitter.github.io/tree-sitter/"
        LANGUAGES C)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(TREE_SITTER_FEATURE_WASM "Enable the Wasm feature" OFF)
option(AMALGAMATED "Build using an amalgamated source" OFF)

if(AMALGAMATED)
  set(TS_SOURCE_FILES "${PROJECT_SOURCE_DIR}/src/lib.c")
else()
  file(GLOB TS_SOURCE_FILES src/*.c)
  list(REMOVE_ITEM TS_SOURCE_FILES "${PROJECT_SOURCE_DIR}/src/lib.c")
endif()

add_library(tree-sitter ${TS_SOURCE_FILES})

target_include_directories(tree-sitter PRIVATE src src/wasm include)

if(MSVC)
  target_compile_options(tree-sitter PRIVATE
                         /wd4018 # disable 'signed/unsigned mismatch'
                         /wd4232 # disable 'nonstandard extension used'
                         /wd4244 # disable 'possible loss of data'
                         /wd4267 # disable 'possible loss of data (size_t)'
                         /wd4701 # disable 'potentially uninitialized local variable'
                         /we4022 # treat 'incompatible types' as an error
                         /W4)
else()
  target_compile_options(tree-sitter PRIVATE
                         -Wall -Wextra -Wshadow -Wpedantic
                         -Werror=incompatible-pointer-types)
endif()

if(TREE_SITTER_FEATURE_WASM)
  if(NOT DEFINED CACHE{WASMTIME_INCLUDE_DIR})
    message(CHECK_START "Looking for wasmtime headers")
    find_path(WASMTIME_INCLUDE_DIR wasmtime.h
              PATHS ENV DEP_WASMTIME_C_API_INCLUDE)
    if(NOT WASMTIME_INCLUDE_DIR)
      unset(WASMTIME_INCLUDE_DIR CACHE)
      message(FATAL_ERROR "Could not find wasmtime headers.\nDid you forget to set CMAKE_INCLUDE_PATH?")
    endif()
    message(CHECK_PASS "found")
  endif()

  if(NOT DEFINED CACHE{WASMTIME_LIBRARY})
    message(CHECK_START "Looking for wasmtime library")
    find_library(WASMTIME_LIBRARY wasmtime)
    if(NOT WASMTIME_LIBRARY)
      unset(WASMTIME_LIBRARY CACHE)
      message(FATAL_ERROR "Could not find wasmtime library.\nDid you forget to set CMAKE_LIBRARY_PATH?")
    endif()
    message(CHECK_PASS "found")
  endif()

  target_compile_definitions(tree-sitter PUBLIC TREE_SITTER_FEATURE_WASM)
  target_include_directories(tree-sitter SYSTEM PRIVATE "${WASMTIME_INCLUDE_DIR}")
  target_link_libraries(tree-sitter PUBLIC "${WASMTIME_LIBRARY}")
  set_property(TARGET tree-sitter PROPERTY C_STANDARD_REQUIRED ON)

  if(NOT BUILD_SHARED_LIBS)
    if(WIN32)
      target_compile_definitions(tree-sitter PRIVATE WASM_API_EXTERN= WASI_API_EXTERN=)
      target_link_libraries(tree-sitter INTERFACE ws2_32 advapi32 userenv ntdll shell32 ole32 bcrypt)
    elseif(NOT APPLE)
      target_link_libraries(tree-sitter INTERFACE pthread dl m)
    endif()
  endif()
endif()

set_target_properties(tree-sitter
                      PROPERTIES
                      C_STANDARD 11
                      C_VISIBILITY_PRESET hidden
                      POSITION_INDEPENDENT_CODE ON
                      SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
                      DEFINE_SYMBOL "")

target_compile_definitions(tree-sitter PRIVATE _POSIX_C_SOURCE=200112L _DEFAULT_SOURCE)

include(GNUInstallDirs)

configure_file(tree-sitter.pc.in "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter.pc" @ONLY)

install(FILES include/tree_sitter/api.h
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/tree_sitter")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
install(TARGETS tree-sitter
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

=== debian/changelog ===
tree-sitter (0.25.6-3) experimental; urgency=medium

  * Remove version constraint for Breaks/Replaces of libtree-sitter0.22
    (Closes: #1108626)
  * libtree-sitter0.25: Add Breaks/Replaces against libtree-sitter0

 -- James McCoy <jamessan@debian.org>  Fri, 04 Jul 2025 09:20:04 -0400

tree-sitter (0.25.6-2) experimental; urgency=medium

  * Include main package version in librust-tree-sitter-dev version to ensure
    it changes with every upload, even if the crate version didn't change.
    (Closes: #1108220)

 -- James McCoy <jamessan@debian.org>  Mon, 23 Jun 2025 11:51:17 -0400

tree-sitter (0.25.6-1) experimental; urgency=medium

  * Update to new upstream version 0.25.6.
  * autopkgtests: Use versioned Provides to ensure the right package is installed

 -- James McCoy <jamessan@debian.org>  Sat, 21 Jun 2025 07:48:34 -0400

tree-sitter (0.25.4-1) experimental; urgency=medium

  * Update to new upstream version 0.25.4. (Closes: #1082967)
  * Update SONAME to libtree-sitter0.25
  * Add librust-tree-sitter-generate-dev package
  * Add librust-tree-sitter-language-dev package
  * Add autopkgtests for tree-sitter-generate and tree-sitter-language
  * Move all non-debhelper Build-Depends to Build-Depends-Arch, since only
    Arch: any packages are built
  * tree-sitter-loader: Add Provides for t-s-highlight and t-s-tags features
  * tree-sitter: Add provides for std feature
  * autopkgtest: Add bindgen dependency for tree-sitter --all-features test
  * lintian: Suppress package-contains-no-arch-dependent-files for
    librust-*-dev packages

 -- James McCoy <jamessan@debian.org>  Sun, 15 Jun 2025 08:16:05 -0400

=== debian/control ===
Source: tree-sitter
Priority: optional
Maintainer: Tree-sitter Maintainers <team+tree-sitter@tracker.debian.org>
Uploaders:
 James McCoy <jamessan@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-rust,
Build-Depends-Arch:
 cargo:native,
 librust-ansi-colours-1+default-dev (>= 1.2.3-~~),
 librust-anstyle-1+default-dev (>= 1.0.8-~~),
 librust-anyhow-1+default-dev (>= 1.0.95-~~),
 librust-bstr-1+default-dev (>= 1.11.3-~~),
 librust-cc-1+default-dev (>= 1.2.10-~~),
 librust-clap-4+cargo-dev (>= 4.5.23-~~),
 librust-clap-4+default-dev (>= 4.5.23-~~),
 librust-clap-4+derive-dev (>= 4.5.23-~~),
 librust-clap-4+env-dev (>= 4.5.23-~~),
 librust-clap-4+help-dev (>= 4.5.23-~~),
 librust-clap-4+unstable-styles-dev (>= 4.5.23-~~),
 librust-clap-complete-4+default-dev (>= 4.5.40-~~),
 librust-ctor+default-dev (<< 0.3-~~),
 librust-ctor+default-dev (>= 0.1-~~),
 librust-ctrlc-3+default-dev (>= 3.4.5-~~),
 librust-ctrlc-3+termination-dev (>= 3.4.5-~~),
 librust-dialoguer-0.11+default-dev,
 librust-dialoguer-0.11+fuzzy-select-dev,
 librust-encoding-rs-0.8+default-dev (>= 0.8.35-~~),
 librust-etcetera-0.8+default-dev,
 librust-filetime-0.2+default-dev (>= 0.2.24-~~),
 librust-fs4+default-dev (<< 0.13-~~),
 librust-fs4+default-dev (>= 0.11-~~),
 librust-glob-0.3+default-dev (>= 0.3.2-~~),
 librust-heck-0.5+default-dev,
 librust-html-escape-0.2+default-dev (>= 0.2.13-~~),
 librust-indexmap-2+default-dev (>= 2.7.0-~~),
 librust-indoc-2+default-dev (>= 2.0.5-~~),
 librust-libloading-0.8+default-dev (>= 0.8.5-~~),
 librust-log-0.4+default-dev (>= 0.4.25-~~),
 librust-log-0.4+std-dev (>= 0.4.25-~~),
 librust-memchr-2+default-dev (>= 2.7.4-~~),
 librust-once-cell-1+default-dev (>= 1.20.2-~~),
 librust-path-slash-0.2+default-dev (>= 0.2.1-~~),
 librust-pretty-assertions-1+default-dev (>= 1.4.0-~~),
 librust-proc-macro2-1+default-dev (>= 1.0.91-~~) <!nocheck>,
 librust-rand-0.8+default-dev (>= 0.8.5-~~),
 librust-regex-1+default-dev (>= 1.11.1-~~),
 librust-regex-1+perf-dev (>= 1.11.1-~~),
 librust-regex-1+std-dev (>= 1.11.1-~~),
 librust-regex-1+unicode-dev (>= 1.11.1-~~),
 librust-regex-syntax-0.8+default-dev (>= 0.8.5-~~),
 librust-regex-syntax-0.8+unicode-dev (>= 0.8.5-~~),
 librust-regex-syntax-0.8-dev (>= 0.8.5-~~),
 librust-rustc-hash-1+default-dev (>= 1.1.0-~~),
 librust-semver-1+default-dev (>= 1.0.23-~~),
 librust-semver-1+serde-dev (>= 1.0.23-~~),
 librust-serde-1+default-dev (>= 1.0.217-~~),
 librust-serde-1+derive-dev (>= 1.0.217-~~),
 librust-serde-derive-1+default-dev (>= 1.0.217-~~),
 librust-serde-json-1+default-dev (>= 1.0.137-~~),
 librust-serde-json-1+preserve-order-dev (>= 1.0.137-~~),
 librust-similar-2+default-dev (>= 2.7.0-~~),
 librust-smallbitvec-2+default-dev (>= 2.5.1-~~),
 librust-streaming-iterator-0.1+default-dev (>= 0.1.9-~~),
 librust-tempfile-3+default-dev (>= 3.15.0-~~),
 librust-thiserror-2+default-dev (>= 2.0.11-~~),
 librust-tiny-http-0.12+default-dev,
 librust-unindent-0.2+default-dev (>= 0.2.3-~~),
 librust-url-2+default-dev (>= 2.5.4-~~),
 librust-url-2+serde-dev (>= 2.5.4-~~),
 librust-walkdir-2+default-dev (>= 2.5.0-~~),
 librust-webbrowser+default-dev (<< 2-~~),
 librust-webbrowser+default-dev (>= 0.8-~~),
 librust-widestring-1+default-dev (>= 1.1.0-~~),
 libstd-rust-dev,
 rustc:native (>= 1.82),
Standards-Version: 4.7.2
Section: libs
Homepage: https://tree-sitter.github.io/tree-sitter/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter.git -b debian/experimental
Vcs-Browser: https://salsa.debian.org/tree-sitter-team/tree-sitter

Package: libtree-sitter-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libtree-sitter0.25 (= ${binary:Version}),
 ${misc:Depends},
Description: incremental parsing system for programming tools (development files)
 Tree-sitter is a parser generator tool and an incremental parsing library. It
 can build a concrete syntax tree for a source file and efficiently update the
 syntax tree as the source file is edited.
 .
 Tree-sitter aims to be:
 .
  * General enough to parse any programming language
  * Fast enough to parse on every keystroke in a text editor
  * Robust enough to provide useful results even in the presence of
    syntax errors
  * Dependency-free so that the runtime library (which is written in pure
    C) can be embedded in any application
 .
 This package contains the header files and libraries needed for developing
 with tree-sitter.

Package: libtree-sitter0.25
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Architecture: any
Breaks: libtree-sitter0, libtree-sitter0.22
Replaces: libtree-sitter0, libtree-sitter0.22
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: incremental parsing system for programming tools
 Tree-sitter is a parser generator tool and an incremental parsing library. It
 can build a concrete syntax tree for a source file and efficiently update the
 syntax tree as the source file is edited.

Package: librust-tree-sitter-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 librust-cc-1+default-dev (>= 1.2.10-~~),
 librust-regex-1+perf-dev (>= 1.11.1-~~),
 librust-regex-1+std-dev (>= 1.11.1-~~),
 librust-regex-1+unicode-dev (>= 1.11.1-~~),
 librust-regex-syntax-0.8+unicode-dev (>= 0.8.5-~~),
 librust-regex-syntax-0.8-dev (>= 0.8.5-~~),
 librust-serde-json-1+default-dev (>= 1.0.137-~~),
 librust-serde-json-1+preserve-order-dev (>= 1.0.137-~~),
 librust-streaming-iterator-0.1+default-dev (>= 0.1.9-~~),
 librust-tree-sitter-language-0.1+default-dev,
 ${misc:Depends},
Provides:
 librust-tree-sitter+default-dev (= ${binary:Version}),
 librust-tree-sitter+std-dev (= ${binary:Version}),
 librust-tree-sitter-0+default-dev (= ${binary:Version}),
 librust-tree-sitter-0+std-dev (= ${binary:Version}),
 librust-tree-sitter-0-dev (= ${binary:Version}),
 librust-tree-sitter-0.25+default-dev (= ${binary:Version}),
 librust-tree-sitter-0.25+std-dev (= ${binary:Version}),
 librust-tree-sitter-0.25-dev (= ${binary:Version}),
 librust-tree-sitter-0.25.6+default-dev (= ${binary:Version}),
 librust-tree-sitter-0.25.6+std-dev (= ${binary:Version}),
 librust-tree-sitter-0.25.6-dev (= ${binary:Version}),
Description: bindings to the tree-sitter parsing library - Rust source code
 Tree-sitter is a parser generator tool and an incremental parsing library. It
 can build a concrete syntax tree for a source file and efficiently update the
 syntax tree as the source file is edited.
 .
 This package contains the source for the Rust tree-sitter crate,
 packaged for use with cargo and dh-cargo.

Package: librust-tree-sitter-cli-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 librust-ansi-colours-1+default-dev (>= 1.2.3-~~),
 librust-anstyle-1+default-dev (>= 1.0.8-~~),
 librust-anyhow-1+default-dev (>= 1.0.95-~~),
 librust-bstr-1+default-dev (>= 1.11.3-~~),
 librust-clap-4+cargo-dev (>= 4.5.23-~~),
 librust-clap-4+default-dev (>= 4.5.23-~~),
 librust-clap-4+derive-dev (>= 4.5.23-~~),
 librust-clap-4+env-dev (>= 4.5.23-~~),
 librust-clap-4+help-dev (>= 4.5.23-~~),
 librust-clap-4+unstable-styles-dev (>= 4.5.23-~~),
 librust-clap-complete-4+default-dev (>= 4.5.40-~~),
 librust-ctor+default-dev (<< 0.3-~~),
 librust-ctor+default-dev (>= 0.1-~~),
 librust-ctrlc-3+default-dev (>= 3.4.5-~~),
 librust-ctrlc-3+termination-dev (>= 3.4.5-~~),
 librust-dialoguer-0.11+default-dev,
 librust-dialoguer-0.11+fuzzy-select-dev,
 librust-filetime-0.2+default-dev (>= 0.2.24-~~),
 librust-glob-0.3+default-dev (>= 0.3.2-~~),
 librust-heck-0.5+default-dev,
 librust-html-escape-0.2+default-dev (>= 0.2.13-~~),
 librust-indexmap-2+default-dev (>= 2.7.0-~~),
 librust-indoc-2+default-dev (>= 2.0.5-~~),
 librust-log-0.4+default-dev (>= 0.4.25-~~),
 librust-log-0.4+std-dev (>= 0.4.25-~~),
 librust-memchr-2+default-dev (>= 2.7.4-~~),
 librust-rand-0.8+default-dev (>= 0.8.5-~~),
 librust-regex-1+default-dev (>= 1.11.1-~~),
 librust-regex-syntax-0.8+default-dev (>= 0.8.5-~~),
 librust-rustc-hash-1+default-dev (>= 1.1.0-~~),
 librust-semver-1+default-dev (>= 1.0.23-~~),
 librust-semver-1+serde-dev (>= 1.0.23-~~),
 librust-serde-1+default-dev (>= 1.0.217-~~),
 librust-serde-1+derive-dev (>= 1.0.217-~~),
 librust-serde-derive-1+default-dev (>= 1.0.217-~~),
 librust-serde-json-1+default-dev (>= 1.0.137-~~),
 librust-serde-json-1+preserve-order-dev (>= 1.0.137-~~),
 librust-similar-2+default-dev (>= 2.7.0-~~),
 librust-smallbitvec-2+default-dev (>= 2.5.1-~~),
 librust-streaming-iterator-0.1+default-dev (>= 0.1.9-~~),
 librust-tiny-http-0.12+default-dev,
 librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~),
 librust-tree-sitter-config-0.25+default-dev (>= 0.25.1-~~),
 librust-tree-sitter-generate-0.25+default-dev (>= 0.25.1-~~),
 librust-tree-sitter-highlight-0.25+default-dev (>= 0.25.1-~~),
 librust-tree-sitter-loader-0.25+default-dev (>= 0.25.1-~~),
 librust-tree-sitter-tags-0.25+default-dev (>= 0.25.1-~~),
 librust-url-2+default-dev (>= 2.5.4-~~),
 librust-url-2+serde-dev (>= 2.5.4-~~),
 librust-walkdir-2+default-dev (>= 2.5.0-~~),
 librust-webbrowser+default-dev (<< 2-~~),
 librust-webbrowser+default-dev (>= 0.8-~~),
 ${misc:Depends},
Provides:
 librust-tree-sitter-cli+default-dev (= ${binary:Version}),
 librust-tree-sitter-cli-0+default-dev (= ${binary:Version}),
 librust-tree-sitter-cli-0-dev (= ${binary:Version}),
 librust-tree-sitter-cli-0.25+default-dev (= ${binary:Version}),
 librust-tree-sitter-cli-0.25-dev (= ${binary:Version}),
 librust-tree-sitter-cli-0.25.6+default-dev (= ${binary:Version}),
 librust-tree-sitter-cli-0.25.6-dev (= ${binary:Version}),
Description: command-line for Tree-sitter parsers - Rust source code
 Tree-sitter is a parser generator tool and an incremental parsing library. It
 can build a concrete syntax tree for a source file and efficiently update the
 syntax tree as the source file is edited.
 .
 This package contains the source for the Rust tree-sitter-cli crate,
 packaged for use with cargo and dh-cargo.

Package: librust-tree-sitter-config-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 librust-anyhow-1+default-dev (>= 1.0.95-~~),
 librust-etcetera-0.8+default-dev,
 librust-serde-1+default-dev (>= 1.0.217-~~),
 librust-serde-1+derive-dev (>= 1.0.217-~~),
 librust-serde-json-1+default-dev (>= 1.0.137-~~),
 librust-serde-json-1+preserve-order-dev (>= 1.0.137-~~),
 ${misc:Depends},
Provides:
 librust-tree-sitter-config+default-dev (= ${binary:Version}),
 librust-tree-sitter-config-0+default-dev (= ${binary:Version}),
 librust-tree-sitter-config-0-dev (= ${binary:Version}),
 librust-tree-sitter-config-0.25+default-dev (= ${binary:Version}),
 librust-tree-sitter-config-0.25-dev (= ${binary:Version}),
 librust-tree-sitter-config-0.25.6+default-dev (= ${binary:Version}),
 librust-tree-sitter-config-0.25.6-dev (= ${binary:Version}),
Description: user configuration of tree-sitter's CLI programs - Rust source code
 Tree-sitter is a parser generator tool and an incremental parsing library. It
 can build a concrete syntax tree for a source file and efficiently update the
 syntax tree as the source file is edited.
 .
 This package contains the source for the Rust tree-sitter-config crate,
 packaged for use with cargo and dh-cargo.

Package: librust-tree-sitter-generate-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 librust-anyhow-1+default-dev (>= 1.0.95-~~),
 librust-heck-0.5+default-dev,
 librust-indexmap-2+default-dev (>= 2.7.0-~~),
 librust-indoc-2+default-dev (>= 2.0.5-~~),
 librust-log-0.4+default-dev (>= 0.4.25-~~),
 librust-log-0.4+std-dev (>= 0.4.25-~~),
 librust-regex-1+default-dev (>= 1.11.1-~~),
 librust-regex-syntax-0.8+default-dev (>= 0.8.5-~~),
 librust-rustc-hash-1+default-dev (>= 1.1.0-~~),
 librust-semver-1+default-dev (>= 1.0.23-~~),
 librust-semver-1+serde-dev (>= 1.0.23-~~),
 librust-serde-1+default-dev (>= 1.0.217-~~),
 librust-serde-1+derive-dev (>= 1.0.217-~~),
 librust-serde-json-1+default-dev (>= 1.0.137-~~),
 librust-serde-json-1+preserve-order-dev (>= 1.0.137-~~),

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter 0.25.6 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-dev:@,
Depends:
 dh-rust,
 librust-bindgen-0.71+default-dev (>= 0.71.1-~~),
 librust-tree-sitter-0.25.6-dev,
 rustc (>= 1.76),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter 0.25.6 --all-targets
Features:
 test-name=librust-tree-sitter-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-0.25.6+default-dev,
 rustc (>= 1.76),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter 0.25.6 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-dev:,
Depends:
 dh-rust,
 librust-tree-sitter-0.25.6-dev,
 rustc (>= 1.76),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-config 0.25.6 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-config-dev:@,
Depends:
 dh-rust,
 librust-tree-sitter-config-0.25.6-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-config 0.25.6 --all-targets
Features:
 test-name=librust-tree-sitter-config-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-config-0.25.6+default-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-config 0.25.6 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-config-dev:,
Depends:
 dh-rust,
 librust-tree-sitter-config-0.25.6-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-generate 0.25.6 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-generate-dev:@,
Depends:
 dh-rust,
 librust-tree-sitter-generate-0.25.6-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-generate 0.25.6 --all-targets
Features:
 test-name=librust-tree-sitter-generate-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-generate-0.25.6+default-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-generate 0.25.6 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-generate-dev:,
Depends:
 dh-rust,
 librust-tree-sitter-generate-0.25.6-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-highlight 0.25.6 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-highlight-dev:@,
Depends:
 dh-rust,
 librust-tree-sitter-highlight-0.25.6-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-highlight 0.25.6 --all-targets
Features:
 test-name=librust-tree-sitter-highlight-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-highlight-0.25.6+default-dev,
 rustc (>= 1.82),
Restrictions:

## tree-sitter 0.25.9

=== Makefile ===
ifeq ($(OS),Windows_NT)
$(error Windows is not supported)
endif

VERSION := 0.25.9
DESCRIPTION := An incremental parsing system for programming tools
HOMEPAGE_URL := https://tree-sitter.github.io/tree-sitter/

# install directory layout
PREFIX ?= /usr/local
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
PCLIBDIR ?= $(LIBDIR)/pkgconfig

# collect sources
ifneq ($(AMALGAMATED),1)
	SRC := $(wildcard lib/src/*.c)
	# do not double-include amalgamation
	SRC := $(filter-out lib/src/lib.c,$(SRC))
else
	# use amalgamated build
	SRC := lib/src/lib.c
endif
OBJ := $(SRC:.c=.o)

# define default flags, and override to append mandatory flags
ARFLAGS := rcs
CFLAGS ?= -O3 -Wall -Wextra -Wshadow -Wpedantic -Werror=incompatible-pointer-types
override CFLAGS += -std=c11 -fPIC -fvisibility=hidden
override CFLAGS += -D_POSIX_C_SOURCE=200112L -D_DEFAULT_SOURCE
override CFLAGS += -Ilib/src -Ilib/src/wasm -Ilib/include

# ABI versioning
SONAME_MAJOR := $(word 1,$(subst ., ,$(VERSION)))
SONAME_MINOR := $(word 2,$(subst ., ,$(VERSION)))

# OS-specific bits
ifneq ($(findstring darwin,$(shell $(CC) -dumpmachine)),)
	SOEXT = dylib
	SOEXTVER_MAJOR = $(SONAME_MAJOR).$(SOEXT)
	SOEXTVER = $(SONAME_MAJOR).$(SONAME_MINOR).$(SOEXT)
	LINKSHARED += -dynamiclib -Wl,-install_name,$(LIBDIR)/libtree-sitter.$(SOEXTVER)
else
	SOEXT = so
	SOEXTVER_MAJOR = $(SOEXT).$(SONAME_MAJOR)
	SOEXTVER = $(SOEXT).$(SONAME_MAJOR).$(SONAME_MINOR)
	LINKSHARED += -shared -Wl,-soname,libtree-sitter.$(SOEXTVER)
endif
ifneq ($(filter $(shell uname),FreeBSD NetBSD DragonFly),)
	PCLIBDIR := $(PREFIX)/libdata/pkgconfig
endif

all: libtree-sitter.a libtree-sitter.$(SOEXT) tree-sitter.pc

libtree-sitter.a: $(OBJ)
	$(AR) $(ARFLAGS) $@ $^

libtree-sitter.$(SOEXT): $(OBJ)
	$(CC) $(LDFLAGS) $(LINKSHARED) $^ $(LDLIBS) -o $@
ifneq ($(STRIP),)
	$(STRIP) $@
endif

tree-sitter.pc: lib/tree-sitter.pc.in
	sed -e 's|@PROJECT_VERSION@|$(VERSION)|' \
		-e 's|@CMAKE_INSTALL_LIBDIR@|$(LIBDIR:$(PREFIX)/%=%)|' \
		-e 's|@CMAKE_INSTALL_INCLUDEDIR@|$(INCLUDEDIR:$(PREFIX)/%=%)|' \
		-e 's|@PROJECT_DESCRIPTION@|$(DESCRIPTION)|' \
		-e 's|@PROJECT_HOMEPAGE_URL@|$(HOMEPAGE_URL)|' \
		-e 's|@CMAKE_INSTALL_PREFIX@|$(PREFIX)|' $< > $@

clean:
	$(RM) $(OBJ) tree-sitter.pc libtree-sitter.a libtree-sitter.$(SOEXT)

install: all
	install -d '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter '$(DESTDIR)$(PCLIBDIR)' '$(DESTDIR)$(LIBDIR)'
	install -m644 lib/include/tree_sitter/api.h '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/api.h
	install -m644 tree-sitter.pc '$(DESTDIR)$(PCLIBDIR)'/tree-sitter.pc
	install -m644 libtree-sitter.a '$(DESTDIR)$(LIBDIR)'/libtree-sitter.a
	install -m755 libtree-sitter.$(SOEXT) '$(DESTDIR)$(LIBDIR)'/libtree-sitter.$(SOEXTVER)
	ln -sf libtree-sitter.$(SOEXTVER) '$(DESTDIR)$(LIBDIR)'/libtree-sitter.$(SOEXTVER_MAJOR)
	ln -sf libtree-sitter.$(SOEXTVER_MAJOR) '$(DESTDIR)$(LIBDIR)'/libtree-sitter.$(SOEXT)

uninstall:
	$(RM) '$(DESTDIR)$(LIBDIR)'/libtree-sitter.a \
		'$(DESTDIR)$(LIBDIR)'/libtree-sitter.$(SOEXTVER) \
		'$(DESTDIR)$(LIBDIR)'/libtree-sitter.$(SOEXTVER_MAJOR) \
		'$(DESTDIR)$(LIBDIR)'/libtree-sitter.$(SOEXT) \
		'$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/api.h \
		'$(DESTDIR)$(PCLIBDIR)'/tree-sitter.pc

.PHONY: all install uninstall clean


##### Dev targets #####

test:
	cargo xtask fetch-fixtures
	cargo xtask generate-fixtures
	cargo xtask test

test-wasm:
	cargo xtask generate-fixtures --wasm
	cargo xtask test-wasm

lint:
	cargo update --workspace --locked --quiet
	cargo check --workspace --all-targets
	cargo fmt --all --check
	cargo clippy --workspace --all-targets -- -D warnings

lint-web:
	npm --prefix lib/binding_web ci
	npm --prefix lib/binding_web run lint

format:
	cargo fmt --all

changelog:
	@git-cliff --config .github/cliff.toml --prepend CHANGELOG.md --latest --github-token $(shell gh auth token)

.PHONY: test test-wasm lint format changelog

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.13)
 
 project(tree-sitter
-        VERSION "0.25.6"
+        VERSION "0.25.9"
         DESCRIPTION "An incremental parsing system for programming tools"
         HOMEPAGE_URL "https://tree-sitter.github.io/tree-sitter/"
         LANGUAGES C)

=== debian/changelog ===
tree-sitter (0.25.9-6) unstable; urgency=medium

  * Use binary, not source, package names for Breaks of vim, vimdoc grammars

 -- James McCoy <jamessan@debian.org>  Mon, 20 Oct 2025 06:23:56 -0400

tree-sitter (0.25.9-5) unstable; urgency=medium

  * Break tree-sitter-*-src packages incompatible with new "tree-sitter test"

 -- James McCoy <jamessan@debian.org>  Sun, 19 Oct 2025 20:11:16 -0400

tree-sitter (0.25.9-4) unstable; urgency=medium

  * Revert "fix(lib): replace raw array accesses with `array_get`" since it's
    triggering the asserts on ppc64el. Building the library with -DNDEBUG
    isn't sufficient.

 -- James McCoy <jamessan@debian.org>  Thu, 16 Oct 2025 21:57:29 -0400

tree-sitter (0.25.9-3) unstable; urgency=medium

  * Remove unnecessary Build-Depends on librust-proc-macro2-dev
  * Add -DNDEBUG to CPPFLAGS in optimized builds (Closes: #1118048)

 -- James McCoy <jamessan@debian.org>  Thu, 16 Oct 2025 09:08:19 -0400

tree-sitter (0.25.9-2) unstable; urgency=medium

  * Upload to unstable (Closes: #1117123)
  * d/control: Relax heck (Build-)Depends to support >= 0.4, << 0.6
  * d/control: Relax fs4 (Build-)Depends to allow 0.13 (Closes: #1117920)

 -- James McCoy <jamessan@debian.org>  Mon, 13 Oct 2025 20:31:00 -0400

tree-sitter (0.25.9-1) experimental; urgency=medium

  * Update to new upstream version 0.25.9.
  * Adjust librust-etcetera-dev dependencies to allow any 0.8 - 0.10 version
  * Remove Rules-Requires-Root: no, since that is the default

 -- James McCoy <jamessan@debian.org>  Sun, 05 Oct 2025 20:05:06 -0400

tree-sitter (0.22.6-8) unstable; urgency=medium

  * Re-upload with patches generated

 -- James McCoy <jamessan@debian.org>  Sat, 13 Sep 2025 15:14:56 -0400

tree-sitter (0.22.6-7) unstable; urgency=medium

  * Bump bindgen dependency to 0.72 (Closes: #1110069)

 -- James McCoy <jamessan@debian.org>  Sat, 13 Sep 2025 14:58:10 -0400

=== debian/control ===
--- 
+++ 
@@ -27,12 +27,14 @@
  librust-dialoguer-0.11+default-dev,
  librust-dialoguer-0.11+fuzzy-select-dev,
  librust-encoding-rs-0.8+default-dev (>= 0.8.35-~~),
- librust-etcetera-0.8+default-dev,
+ librust-etcetera+default-dev (>= 0.8),
+ librust-etcetera+default-dev (<< 0.11),
  librust-filetime-0.2+default-dev (>= 0.2.24-~~),
- librust-fs4+default-dev (<< 0.13-~~),
+ librust-fs4+default-dev (<< 0.14-~~),
  librust-fs4+default-dev (>= 0.11-~~),
  librust-glob-0.3+default-dev (>= 0.3.2-~~),
- librust-heck-0.5+default-dev,
+ librust-heck+default-dev (>= 0.4),
+ librust-heck+default-dev (<< 0.6),
  librust-html-escape-0.2+default-dev (>= 0.2.13-~~),
  librust-indexmap-2+default-dev (>= 2.7.0-~~),
  librust-indoc-2+default-dev (>= 2.0.5-~~),
@@ -43,7 +45,6 @@
  librust-once-cell-1+default-dev (>= 1.20.2-~~),
  librust-path-slash-0.2+default-dev (>= 0.2.1-~~),
  librust-pretty-assertions-1+default-dev (>= 1.4.0-~~),
- librust-proc-macro2-1+default-dev (>= 1.0.91-~~) <!nocheck>,
  librust-rand-0.8+default-dev (>= 0.8.5-~~),
  librust-regex-1+default-dev (>= 1.11.1-~~),
  librust-regex-1+perf-dev (>= 1.11.1-~~),
@@ -66,6 +67,7 @@
  librust-tempfile-3+default-dev (>= 3.15.0-~~),
  librust-thiserror-2+default-dev (>= 2.0.11-~~),
  librust-tiny-http-0.12+default-dev,
+ librust-topological-sort-0.2+default-dev (>= 0.2.2),
  librust-unindent-0.2+default-dev (>= 0.2.3-~~),
  librust-url-2+default-dev (>= 2.5.4-~~),
  librust-url-2+serde-dev (>= 2.5.4-~~),
@@ -78,8 +80,7 @@
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://tree-sitter.github.io/tree-sitter/
-Rules-Requires-Root: no
-Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter.git -b debian/experimental
+Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter.git
 Vcs-Browser: https://salsa.debian.org/tree-sitter-team/tree-sitter
 
 Package: libtree-sitter-dev
@@ -146,9 +147,9 @@
  librust-tree-sitter-0.25+default-dev (= ${binary:Version}),
  librust-tree-sitter-0.25+std-dev (= ${binary:Version}),
  librust-tree-sitter-0.25-dev (= ${binary:Version}),
- librust-tree-sitter-0.25.6+default-dev (= ${binary:Version}),
- librust-tree-sitter-0.25.6+std-dev (= ${binary:Version}),
- librust-tree-sitter-0.25.6-dev (= ${binary:Version}),
+ librust-tree-sitter-0.25.9+default-dev (= ${binary:Version}),
+ librust-tree-sitter-0.25.9+std-dev (= ${binary:Version}),
+ librust-tree-sitter-0.25.9-dev (= ${binary:Version}),
 Description: bindings to the tree-sitter parsing library - Rust source code
  Tree-sitter is a parser generator tool and an incremental parsing library. It
  can build a concrete syntax tree for a source file and efficiently update the
@@ -181,7 +182,8 @@
  librust-dialoguer-0.11+fuzzy-select-dev,
  librust-filetime-0.2+default-dev (>= 0.2.24-~~),
  librust-glob-0.3+default-dev (>= 0.3.2-~~),
- librust-heck-0.5+default-dev,
+ librust-heck+default-dev (>= 0.4),
+ librust-heck+default-dev (<< 0.6),
  librust-html-escape-0.2+default-dev (>= 0.2.13-~~),
  librust-indexmap-2+default-dev (>= 2.7.0-~~),
  librust-indoc-2+default-dev (>= 2.0.5-~~),
@@ -203,6 +205,7 @@
  librust-smallbitvec-2+default-dev (>= 2.5.1-~~),
  librust-streaming-iterator-0.1+default-dev (>= 0.1.9-~~),
  librust-tiny-http-0.12+default-dev,
+ librust-topological-sort-0.2+default-dev (>= 0.2.2),
  librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~),
  librust-tree-sitter-config-0.25+default-dev (>= 0.25.1-~~),
  librust-tree-sitter-generate-0.25+default-dev (>= 0.25.1-~~),
@@ -221,8 +224,8 @@
  librust-tree-sitter-cli-0-dev (= ${binary:Version}),
  librust-tree-sitter-cli-0.25+default-dev (= ${binary:Version}),
  librust-tree-sitter-cli-0.25-dev (= ${binary:Version}),
- librust-tree-sitter-cli-0.25.6+default-dev (= ${binary:Version}),
- librust-tree-sitter-cli-0.25.6-dev (= ${binary:Version}),
+ librust-tree-sitter-cli-0.25.9+default-dev (= ${binary:Version}),
+ librust-tree-sitter-cli-0.25.9-dev (= ${binary:Version}),
 Description: command-line for Tree-sitter parsers - Rust source code
  Tree-sitter is a parser generator tool and an incremental parsing library. It
  can build a concrete syntax tree for a source file and efficiently update the
@@ -237,7 +240,8 @@
 Multi-Arch: same
 Depends:
  librust-anyhow-1+default-dev (>= 1.0.95-~~),
- librust-etcetera-0.8+default-dev,
+ librust-etcetera+default-dev (>= 0.8),
+ librust-etcetera+default-dev (<< 0.11),
  librust-serde-1+default-dev (>= 1.0.217-~~),
  librust-serde-1+derive-dev (>= 1.0.217-~~),
  librust-serde-json-1+default-dev (>= 1.0.137-~~),
@@ -249,8 +253,8 @@
  librust-tree-sitter-config-0-dev (= ${binary:Version}),
  librust-tree-sitter-config-0.25+default-dev (= ${binary:Version}),
  librust-tree-sitter-config-0.25-dev (= ${binary:Version}),
- librust-tree-sitter-config-0.25.6+default-dev (= ${binary:Version}),
- librust-tree-sitter-config-0.25.6-dev (= ${binary:Version}),
+ librust-tree-sitter-config-0.25.9+default-dev (= ${binary:Version}),
+ librust-tree-sitter-config-0.25.9-dev (= ${binary:Version}),
 Description: user configuration of tree-sitter's CLI programs - Rust source code
  Tree-sitter is a parser generator tool and an incremental parsing library. It
  can build a concrete syntax tree for a source file and efficiently update the
@@ -265,7 +269,8 @@
 Multi-Arch: same
 Depends:
  librust-anyhow-1+default-dev (>= 1.0.95-~~),
- librust-heck-0.5+default-dev,
+ librust-heck+default-dev (>= 0.4),
+ librust-heck+default-dev (<< 0.6),
  librust-indexmap-2+default-dev (>= 2.7.0-~~),
  librust-indoc-2+default-dev (>= 2.0.5-~~),
  librust-log-0.4+default-dev (>= 0.4.25-~~),
@@ -274,8 +279,3 @@
  librust-regex-syntax-0.8+default-dev (>= 0.8.5-~~),
  librust-rustc-hash-1+default-dev (>= 1.1.0-~~),
  librust-semver-1+default-dev (>= 1.0.23-~~),
- librust-semver-1+serde-dev (>= 1.0.23-~~),
- librust-serde-1+default-dev (>= 1.0.217-~~),
- librust-serde-1+derive-dev (>= 1.0.217-~~),
- librust-serde-json-1+default-dev (>= 1.0.137-~~),
- librust-serde-json-1+preserve-order-dev (>= 1.0.137-~~),

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk

# Work around asserts being enabled in all builds
# https://github.com/tree-sitter/tree-sitter/issues/4960
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  CPPFLAGS += -DNDEBUG
endif

CFLAGS += $(CPPFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
	dh_auto_build --buildsystem=rust

# tree-sitter-cli's tests require downloading fixtures at build time, so we can't run those.
# xtask is an internal crate used for release automation
override_dh_auto_test:
	dh_auto_test --buildsystem=rust -- --tests --workspace --exclude tree-sitter-cli --exclude xtask

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
	dh_auto_install --buildsystem=rust

define crate_ver =
$(shell perl -n -E 'if (/^version\s*=\s*"([\d.]+)["~]/) {say "$$1";}' lib/language/Cargo.toml)
endef

override_dh_gencontrol:
	dh_gencontrol -p librust-tree-sitter-language-dev -- -v$(crate_ver)+$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol --remaining-packages

=== debian/tests/control ===
Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter 0.25.9 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-dev:@,
Depends:
 dh-rust,
 librust-bindgen-0.72+default-dev,
 librust-tree-sitter-0.25.9-dev,
 rustc (>= 1.76),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter 0.25.9 --all-targets
Features:
 test-name=librust-tree-sitter-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-0.25.9+default-dev,
 rustc (>= 1.76),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter 0.25.9 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-dev:,
Depends:
 dh-rust,
 librust-tree-sitter-0.25.9-dev,
 rustc (>= 1.76),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-config 0.25.9 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-config-dev:@,
Depends:
 dh-rust,
 librust-tree-sitter-config-0.25.9-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-config 0.25.9 --all-targets
Features:
 test-name=librust-tree-sitter-config-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-config-0.25.9+default-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-config 0.25.9 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-config-dev:,
Depends:
 dh-rust,
 librust-tree-sitter-config-0.25.9-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-generate 0.25.9 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-generate-dev:@,
Depends:
 dh-rust,
 librust-tree-sitter-generate-0.25.9-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-generate 0.25.9 --all-targets
Features:
 test-name=librust-tree-sitter-generate-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-generate-0.25.9+default-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-generate 0.25.9 --all-targets --no-default-features
Features:
 test-name=librust-tree-sitter-generate-dev:,
Depends:
 dh-rust,
 librust-tree-sitter-generate-0.25.9-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-highlight 0.25.9 --all-targets --all-features
Features:
 test-name=librust-tree-sitter-highlight-dev:@,
Depends:
 dh-rust,
 librust-tree-sitter-highlight-0.25.9-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test tree-sitter-highlight 0.25.9 --all-targets
Features:
 test-name=librust-tree-sitter-highlight-dev:default,
Depends:
 dh-rust,
 librust-tree-sitter-highlight-0.25.9+default-dev,
 rustc (>= 1.82),
Restrictions:
 allow-stderr,
